#ifndef __LPM_H__
#define __LPM_H__

struct _Pose{
	double x,y,theta;
};
typedef struct _Pose Pose;

#include <math.h>
#include <iostream>
#include <stdio.h>

#ifndef M_PI
#define M_PI (4.0*atan(1.0))
#endif
class LPM{

private:
	double POE(double dist);
	double P_OE(double dist);
	double PO_E(double dist);
	double P_O_E(double dist);

public:
#if 0
	static const int Grid_size=50;
	static const int Map_size=10000;
#endif
	
	int Grid_size;
	int Xmin,Xmax,Ymin,Ymax;
	int XMapSize,YMapSize;
	double **work_map;
	 int **flag;

	double Pose_x;
	double Pose_y;
	double Pose_theta;

	LPM(int Xmin,int Xmax,int Ymin,int Ymax,int Grid_size);
	~LPM();
	double **map;
	//void LPM::MapUpdate(Pose p_diff,double *dist,double theta_start,double theta_end,int data_num,double min_dist,double max_dist,Pose sensor);
	void LPM::MapUpdate(Pose p_diff,double *dist,double theta_start,double theta_end,int data_num,double min_dist,double max_dist,Pose sensor);
	//09.1.16 add value mindist
	void set_pose(double input_x,double input_y,double input_theta){
	 Pose_x= input_x;
	 Pose_y=input_y;
	 Pose_theta=input_theta;
	}
};


#endif