//------------------------------------------------------------------------------------------------+
// MRFCSVC_impl.h
// Service implementation header of MRFC.idl
//------------------------------------------------------------------------------------------------+

#include "BasicDataTypeSkel.h"
#include "ExtendedDataTypesSkel.h"
#include "InterfaceDataTypesSkel.h"

#include "MRFCSkel.h"

#ifndef MRFCSVC_IMPL_H
#define MRFCSVC_IMPL_H


//------------------------------------------------------------------------------------------------+
// RelativeMapServiceSVC_impl
//------------------------------------------------------------------------------------------------+
class RelativeMapServiceSVC_impl
 : public virtual POA_MRFC::RelativeMapService,
   public virtual PortableServer::RefCountServantBase
{
private:
	MRFC::TimedRelativeOGMapData *mapdata;
	CRITICAL_SECTION *c_section;

public:
	RelativeMapServiceSVC_impl( MRFC::TimedRelativeOGMapData *localmap, CRITICAL_SECTION *cs );
	virtual ~RelativeMapServiceSVC_impl();

	RTC::OGMapConfig getRelativeOGMapConfig();
	MRFC::TimedRelativeOGMapData *getRelativeOGMap();
	MRFC::TimedFloatRelativeOGMapData *getFloatRelativeOGMap();
};


#endif // MRFCSVC_IMPL_H
